package io.github.znetworkw.znpcservers.npc;

import com.github.retrooper.packetevents.protocol.player.EquipmentSlot;
import io.github.znetworkw.znpcservers.npc.conversation.ConversationModel;
import io.github.znetworkw.znpcservers.utility.location.ZLocation;
import org.bukkit.inventory.ItemStack;

import java.util.*;

@SuppressWarnings("unused")
public class NPCModel {
    private int id;
    private UUID uuid;
    private double hologramHeight;
    private String skin;
    private String signature;
    private String pathName;
    private String glowName;
    private ConversationModel conversation;
    private ZLocation location;
    private NPCType npcType;
    private boolean shouldSpawn;
    private List<String> hologramLines;
    private List<NPCAction> clickActions;
    private Map<EquipmentSlot, ItemStack> npcEquip;
    private Map<String, Boolean> npcFunctions;
    private Map<String, String[]> customizationMap;

    public NPCModel(int id) {
        this.id = id;
        this.uuid = UUID.randomUUID();
        this.skin = "";
        this.signature = "";
        this.npcType = NPCType.PLAYER;
        this.shouldSpawn = true;
        this.hologramLines = Collections.singletonList("/znpcs lines");
        this.clickActions = new ArrayList<>();
        this.npcEquip = new HashMap<>();
        this.customizationMap = new HashMap<>();
        this.npcFunctions = new HashMap<>();
        this.npcFunctions.put("holo", Boolean.TRUE);
    }

    public int getId() {
        return this.id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public NPCModel withId(int id) {
        setId(id);
        return this;
    }

    public UUID getUuid() {
        if (this.uuid == null) this.uuid = UUID.randomUUID();
        return this.uuid;
    }

    public void setUuid(UUID uuid) {
        this.uuid = uuid;
    }

    public double getHologramHeight() {
        return this.hologramHeight;
    }

    public void setHologramHeight(double hologramHeight) {
        this.hologramHeight = hologramHeight;
    }

    public NPCModel withHologramHeight(double hologramHeight) {
        setHologramHeight(hologramHeight);
        return this;
    }

    public String getSkin() {
        return this.skin;
    }

    public void setSkin(String skin) {
        this.skin = skin;
    }

    public NPCModel withSkin(String skin) {
        setSkin(skin);
        return this;
    }

    public String getSignature() {
        return this.signature;
    }

    public void setSignature(String signature) {
        this.signature = signature;
    }

    public NPCModel withSignature(String signature) {
        setSignature(signature);
        return this;
    }

    public String getPathName() {
        return this.pathName;
    }

    public void setPathName(String pathName) {
        this.pathName = pathName;
    }

    public NPCModel withPathName(String pathName) {
        setPathName(pathName);
        return this;
    }

    public String getGlowName() {
        return this.glowName;
    }

    public void setGlowName(String glowName) {
        this.glowName = glowName;
    }

    public NPCModel withGlowName(String glowName) {
        setGlowName(this.pathName);
        return this;
    }

    public ConversationModel getConversation() {
        return this.conversation;
    }

    public void setConversation(ConversationModel conversation) {
        this.conversation = conversation;
    }

    public NPCModel withConversation(ConversationModel conversation) {
        setConversation(conversation);
        return this;
    }

    public List<String> getHologramLines() {
        return this.hologramLines;
    }

    public void setHologramLines(List<String> hologramLines) {
        this.hologramLines = hologramLines;
    }

    public NPCModel withHologramLines(List<String> hologramLines) {
        setHologramLines(hologramLines);
        return this;
    }

    public ZLocation getLocation() {
        return this.location;
    }

    public void setLocation(ZLocation location) {
        this.location = location;
    }

    public NPCModel withLocation(ZLocation location) {
        setLocation(location);
        return this;
    }

    public NPCType getNpcType() {
        return this.npcType;
    }

    public void setNpcType(NPCType npcType) {
        this.npcType = npcType;
    }

    public NPCModel withNpcType(NPCType npcType) {
        setNpcType(npcType);
        return this;
    }

    public boolean getShouldSpawn() {
        return this.shouldSpawn;
    }

    public void setShouldSpawn(boolean shouldSpawn) {
        this.shouldSpawn = shouldSpawn;
    }

    public NPCModel withShouldSpawn(boolean shouldSpawn) {
        setShouldSpawn(shouldSpawn);
        return this;
    }

    public List<NPCAction> getClickActions() {
        return this.clickActions;
    }

    public void setClickActions(List<NPCAction> clickActions) {
        this.clickActions = clickActions;
    }

    public NPCModel withClickActions(List<NPCAction> clickActions) {
        setClickActions(clickActions);
        return this;
    }

    public Map<EquipmentSlot, ItemStack> getNpcEquip() {
        return this.npcEquip;
    }

    public void setNpcEquip(Map<EquipmentSlot, ItemStack> npcEquip) {
        this.npcEquip = npcEquip;
    }

    public NPCModel withNpcEquip(Map<EquipmentSlot, ItemStack> npcEquip) {
        setNpcEquip(npcEquip);
        return this;
    }

    public Map<String, String[]> getCustomizationMap() {
        return this.customizationMap;
    }

    public void setCustomizationMap(Map<String, String[]> customizationMap) {
        this.customizationMap = customizationMap;
    }

    public NPCModel withCustomizationMap(Map<String, String[]> customizationMap) {
        setCustomizationMap(customizationMap);
        return this;
    }

    public Map<String, Boolean> getFunctions() {
        return this.npcFunctions;
    }

    public void setFunctions(Map<String, Boolean> npcFunctions) {
        this.npcFunctions = npcFunctions;
    }

    public NPCModel withFunctionValues(Map<String, Boolean> npcFunctions) {
        setFunctions(npcFunctions);
        return this;
    }
}
